config/routes.rb
Rails.application.routes.draw do
  get 'order_items/show'
  get 'checkouts/index'
  resources :order_items
  resources :cart
  devise_for :users, :controllers => { registrations: 'registrations'}
  resources :admins
  resources :users
  resources :products
  resources :vendors
  resources :orders
  root to: "home#index"
  get 'home/index'
  post "checkout/create", to: "checkout#create"
  post "products/add_to_cart/:id", to: "products#add_to_cart", as: "add_to_cart"
  delete "products/remove_from_cart/:id", to: "products#remove_from_cart", as: "remove_from_cart"
  # resources :webhooks, only: [:create]
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/order.rb
class Order < ApplicationRecord
  has_many :order_items, dependent: :destroy
  has_one :user
end

app/models/order_item.rb
class OrderItem < ApplicationRecord
	belongs_to :order
	belongs_to :product
end

app/models/product.rb
class Product < ApplicationRecord
  belongs_to :user

  has_many_attached :images

  has_many :order_items
end

app/models/role.rb
class Role < ApplicationRecord
  has_and_belongs_to_many :users, :join_table => :users_roles
  
  belongs_to :resource,
             :polymorphic => true,
             :optional => true
  

  validates :resource_type,
            :inclusion => { :in => Rolify.resource_types },
            :allow_nil => true

  scopify
end

app/models/user.rb
class User < ApplicationRecord
  has_many :products, :dependent => :destroy
  has_many :order
  
  rolify
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable, :trackable
  
  after_create :assign_default_role

  validate :must_have_a_role, on: :update

  validate :must_have_a_role, on: :new

  after_create do 
    customer = Stripe::Customer.create(email: email)
    update(stripe_customer_id: customer.id)
  end

  private

  def must_have_a_role
    unless roles.any?
      errors.add(:roles, "Must have at least 1 role")
    end
  end

  def assign_default_role
    self.add_role(:User) if self.roles.blank?
  end

end

app/controllers/admins_controller.rb
class AdminsController < ApplicationController
    before_action :confirm_role
    def index
        @users = User.all
    end
    def show
        @user = User.find(params[:id])
    end
    def edit
        @user = User.find(params[:id])
    end
    def update
        @user = User.find(params[:id])
        if @user.update(user_params)
            redirect_to admins_path, notice: "User successfly updated."
        else
            render :edit
        end
    end
    def delete
        @user = User.find(params[:id])
    end

    def destroy
        user = User.find(params[:id]).destroy
        flash[:notice] = "User '#{user.username}' destroyed successfully."
        redirect_to(:action => 'index')
    end

    private
    def user_params
        params.require(:user).permit({role_ids: []})
    end

    def confirm_role
        unless current_user.has_role? :Admin
          redirect_to root_path, alert: "You are not authorized."
        end
    end
end

app/controllers/cart_controller.rb
class CartController < ApplicationController
  def index
    # if session[:cart]
    #   @products = Product.where(id: session[:cart])
    # end
  end 
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  # before_action :confirm_role
  def index
    if current_user.has_role? :Admin
        redirect_to admins_path
    elsif current_user.has_role? :Vendor
        redirect_to vendors_path
    else
      @products=Product.all
    end
  end
end

app/controllers/orders_controller.rb
class OrdersController < ApplicationController
  def index
    @orders=Order.all
  end

  def show
    user=User.find(params[:id])
    @order=user.order
  end

  def create
    @order=Order.new(order_params)
    if @order.save
      @order_item=(JSON.parse params[:cart]).map{|p| OrderItem.new(p)}
      k=@order_item.length
      k.times { |i| @order_item[i].order = @order }
      k.times { |i| @order_item[i].subtotal = params[:subtotal] }
      k.times { |i| @order_item[i].save }
      respond_to do |format|
        format.json { render :inline => "{}" }
      end
    else
      redirect_to 'checkouts/index'
    end
  end

  def edit
    @orde=Order.find(params[:id])
  end

  def update
    @orde = Order.find(params[:id])
    if @orde.update(update_params)
      flash[:notice] = "Order updated successfully."
      redirect_to orders_path
    else
      render('edit')
    end
  end

  def destroy
    order = Order.find(params[:id]).destroy
    flash[:notice] = "Order destroyed successfully."
    redirect_to order_path(:id => current_user.id)
  end

  private

  def order_params
    params.permit(:user_id, :address)
  end

  def order_item_params
    params.permit(:subtotal, cart: [] )
  end

  def update_params
    params.permit(:status)
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  def update
    @user = User.find(params[:id])
    if @user.update(user_params)
        redirect_to admins_path, notice: "User successfly updated."
    else
        render :edit
    end
  end

  private
  def user_params
    params.require(:user).permit({role_ids: []})
  end
end

app/helpers/admins_helper.rb
module AdminsHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/cart_helper.rb
module CartHelper
end

app/helpers/checkouts_helper.rb
module CheckoutsHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/order_items_helper.rb
module OrderItemsHelper
end

app/helpers/orders_helper.rb
module OrdersHelper
end

app/helpers/product_helper.rb
module ProductHelper
end

app/helpers/registrations_helper.rb
module RegistrationsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/helpers/vendors_helper.rb
module VendorsHelper
end

app/views/cart/index.html.erb
<div class="container p-3">
<%= link_to "<< Continue Shopping", root_path %>
  <h2 class="text-center"> Your Cart Items </h2>
  <div class="table-responsive">
    <table class="table table-striped text-center" id="carttable">

    </table>
  </div>
    <br>
    <hr>
    <br>
    <h4 class="text-right">Subtotal: <span><input id="subtotal" value="" name="subtotal" readonly /></span></h4>
    <div class="text-right p-3">
      <%= button_tag "Proceed to checkout", id:"buybtn", remote: true %>
    </div>  
</div>

<script>
  let subtotal = 0;
  const cardBoxTable = document.querySelector("#carttable");
  let tableData = '';
  tableData += '<tr><th>Title</th><th>Quantity</th><th>Price</th><th>Total</th><th>Action</th></tr>';
  if(JSON.parse(sessionStorage.getItem('items'))[0] === null){
    tableData += '<tr><td colspan="5">No items found</td></tr>'
  }
  else{
    JSON.parse(sessionStorage.getItem('items')).map(data=>{
      tableData += '<tr><td>'+data.title+'</td><td>'+data.quantity+'</td><td>'+data.price+'</td><td>'+data.total+'</td><td><a href="#" onclick=Delete('+data.product_id+');>Delete</a></td></tr>';
      subtotal += data.total
    });
  }
  cardBoxTable.innerHTML = tableData;
  sessionStorage.setItem("subtotal",JSON.stringify(subtotal));
  document.getElementById("subtotal").value=subtotal;

  cart=JSON.parse(sessionStorage.getItem('items'));


function Delete(e){
  let items = [];
  JSON.parse(sessionStorage.getItem('items')).map(data=>{
    if(data.product_id != e){
      items.push(data);
    }
  });
  sessionStorage.setItem('items',JSON.stringify(items));
  window.location.reload();
};
</script>

app/views/home/index.html.erb
<div class="container p-3">
    <h5 class="text-right">
        <%= link_to "Cart", cart_index_path, method: :get%><i class="fas fa-shopping-cart"></i>
        <%= link_to "Your Orders", order_path(current_user), method: :get%>
    </h5>
    <div class="row">
    <% @products.each_with_index do |product, index| %>
        <p hidden id="product_id_<%= index %>"><%= product.id  %></p>
        <div class="col-sm-4 py-2">
            <div class="card">
                <div class="card-body">
                    <ul class="list-unstyled">
                        <% if product.images.attached? %>
                            <% product.images.each do |image| %>
                            <li>
                                <%= image_tag image, width:"200px", height:"300px", class:"card-img-top" %>  
                            </li>
                            <% end %>
                        <% end %>
                    </ul>
                    <hr>
                    <h5 class="card-title text-center" id="title_<%= index %>"><%= product.title %></h5>
                    <p class="card-text">
                    <div class="row">
                        <div class="col text-left">
                            <%= product.description  %>
                        </div>
                        <div class="col text-right">
                            <h5 id="price_<%= index %>"><%= product.price  %></h5>
                        </div>
                    </div>
                    </p>
                    <div class="row">
                        <div class="col text-left">
                            Quantity:
                            <input type="number" id="quantity_<%= index %>" value="1" min="1" max="<%= product.quantity %>" step="1">
                        </div>
                        <div class="col text-right">
                            <button class='addToCart btn btn-primary' >Add to Cart</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    <% end %>
    </div>
</div>


<script>
    const addToCartBtn = document.getElementsByClassName('addToCart');
    let items = [];
    pid="product_id_";
    ptitle="title_";
    pprice="price_"
    qty="quantity_"
    for(let i=0; i<addToCartBtn.length; i++){
        addToCartBtn[i].addEventListener("click",function(e){
            if(typeof(Storage) !== 'undefined'){
                let item = {
                        product_id:parseInt(document.getElementById(pid + i).innerHTML),
                        title:document.getElementById(ptitle + i).innerHTML,
						quantity:parseInt(document.getElementById(qty + i).value),
                        price:parseInt(document.getElementById(pprice + i).innerHTML),
                        total:parseInt(document.getElementById(pprice + i).innerHTML)*parseInt(document.getElementById(qty + i).value)
				};
				if(JSON.parse(sessionStorage.getItem('items')) === null){
					items.push(item);
					sessionStorage.setItem("items",JSON.stringify(items));
					window.location.reload();
				}else{
					const sessionItems = JSON.parse(sessionStorage.getItem("items"));
					sessionItems.map(data=>{
						if(item.product_id == data.product_id){
							item.quantity = parseInt(document.getElementById(qty + i).value);
						}else{
							items.push(data);
						}
					});
					items.push(item);
					sessionStorage.setItem('items',JSON.stringify(items));
					window.location.reload();
				}
            }else{
                alert('session storage is not working on your browser');
            }
        });
    }
</script>